> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Request Details

> Retrieves all the available information for a request that matches a given request id



## OpenAPI

````yaml /api-reference/services_documented/waap_api.yaml get /waap/v1/domains/{domain_id}/requests/{request_id}/details
openapi: 3.1.0
info:
  title: Gcore OpenAPI – WAAP API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-15T06:37:28.230198+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: WAAP Service
    x-displayName: WAAP Service
  - name: Domains
    x-displayName: Domains
  - name: Policies
    x-displayName: Policies
  - name: Analytics
    x-displayName: Analytics
  - name: Custom Page Sets
    x-displayName: Custom Page Sets
  - name: Custom Rules
    x-displayName: Custom Rules
  - name: Filter Templates
    x-displayName: Filter Templates
  - name: Firewall Rules
    x-displayName: Firewall Rules
  - name: Advanced Rules
    x-displayName: Advanced Rules
  - name: Tags
    x-displayName: Tags
  - name: Network Organizations
    x-displayName: Network Organizations
  - name: API Discovery
    x-displayName: API Discovery
  - name: IP Spotlight
    x-displayName: IP Spotlight
  - name: Security Insights
    x-displayName: Security Insights
  - name: IP Reputation
    x-displayName: IP Reputation
paths:
  /waap/v1/domains/{domain_id}/requests/{request_id}/details:
    get:
      tags:
        - Analytics
      summary: Get Request Details
      description: >-
        Retrieves all the available information for a request that matches a
        given request id
      operationId: >-
        get_request_details_v1_domains__domain_id__requests__request_id__details_get
      parameters:
        - name: domain_id
          in: path
          required: true
          schema:
            type: integer
            exclusiveMinimum: 0
            description: The domain ID
            title: Domain Id
          description: The domain ID
        - name: request_id
          in: path
          required: true
          schema:
            type: string
            description: The request ID
            title: Request Id
          description: The request ID
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RequestDetails'
        '400':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-bad-request
                title: Bad Request
                status: 400
                detail: 'Invalid domain name: '''''''''
          description: Bad Request
        '401':
          description: Unauthorized
          content:
            application/problem+json:
              example:
                detail: Auth token is missing or invalid
        '403':
          description: Unauthenticated
          content:
            application/problem+json:
              example:
                detail: Permission denied
        '404':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-not-found
                title: Not Found
                status: 404
                detail: The resource is not found
          description: Not Found
        '422':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APICompositeError'
              example:
                type: request-validation-failed
                title: Request validation error.
                status: 422
                detail: One or more fields have validation errors.
                errors:
                  - loc:
                      - body
                      - name
                    detail: Input should be a valid string
                  - loc:
                      - body
                      - date
                    detail: Field required
                  - loc:
                      - query
                      - limit
                    detail: Field required
          description: Unprocessable Entity
        '500':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: internal-server-error
                title: Internal server error.
                status: 500
                detail: >-
                  An unexpected condition was encountered which prevented the
                  server from fulfilling the request.
          description: Internal Server Error
      x-codeSamples:
        - lang: Python
          source: >-
            import os

            from gcore import Gcore


            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )

            waap_request_details =
            client.waap.domains.statistics.get_request_details(
                request_id="request_id",
                domain_id=1,
            )

            print(waap_request_details.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/option\"\n\t\"github.com/G-Core/gcore-go/waap\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\twaapRequestDetails, err := client.Waap.Domains.Statistics.GetRequestDetails(\n\t\tcontext.TODO(),\n\t\t\"request_id\",\n\t\twaap.DomainStatisticGetRequestDetailsParams{\n\t\t\tDomainID: 1,\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", waapRequestDetails.ID)\n}\n"
components:
  schemas:
    RequestDetails:
      properties:
        id:
          type: string
          title: Id
          description: Request ID
          example: 96763b8fb655e9f18a2e04097b704e39-458959
          examples:
            - 96763b8fb655e9f18a2e04097b704e39-458959
        path:
          type: string
          title: Path
          description: Request path
          example: /new_index
          examples:
            - /new_index
        method:
          type: string
          title: Method
          description: Request method
          example: GET
          examples:
            - GET
        action:
          type: string
          title: Action
          description: Request action
          example: block
          examples:
            - block
        rule_id:
          type: string
          title: Rule Id
          description: ID of the triggered rule
          example: '86'
          examples:
            - '86'
        rule_name:
          type: string
          title: Rule Name
          description: Name of the triggered rule
          example: SQL Injection
          examples:
            - SQL Injection
        user_agent:
          $ref: '#/components/schemas/UserAgent'
          description: User agent
        network:
          $ref: '#/components/schemas/Network'
        request_time:
          type: string
          format: date-time
          title: Request Time
          description: The time of the request
          example: '2025-08-28T07:13:59'
          examples:
            - '2025-08-28T07:13:59'
        reference_id:
          type: string
          title: Reference Id
          description: Reference ID to identify user sanction
          example: ad07c06f19054e484974fa22e9fb6bb1
          examples:
            - ad07c06f19054e484974fa22e9fb6bb1
        session_id:
          type: string
          title: Session Id
          description: The session ID associated with the request.
          example: 0c74d14951b22dc3f22cbba9668ecea1
          examples:
            - 0c74d14951b22dc3f22cbba9668ecea1
        content_type:
          type: string
          title: Content Type
          description: Content type of request
          example: text/html; charset=UTF-8
          examples:
            - text/html; charset=UTF-8
        scheme:
          type: string
          title: Scheme
          description: The URI scheme of the request that generated an event
          example: https
          examples:
            - https
        http_status_code:
          type: integer
          title: Http Status Code
          description: Status code for http request
          example: 200
          examples:
            - 200
        http_version:
          type: string
          title: Http Version
          description: HTTP version of request
          example: '1.1'
          examples:
            - '1.1'
        response_time:
          type: string
          title: Response Time
          description: Time took to process all request
          example: '3'
          examples:
            - '3'
        request_headers:
          additionalProperties: true
          type: object
          title: Request Headers
          description: HTTP request headers
          example:
            ACCEPT: '*/*'
            ACCEPT-ENCODING: gzip, deflate
            CONNECTION: keep-alive
            HOST: oih.jung.fblcloud-qa.net
            USER-AGENT: Firefox/44.3
            X-FORWARDED-FOR: 169.54.212.219
            X-FORWARDED-PORT: '80'
            X-FORWARDED-PROTO: http
          examples:
            - ACCEPT: '*/*'
              ACCEPT-ENCODING: gzip, deflate
              CONNECTION: keep-alive
              HOST: oih.jung.fblcloud-qa.net
              USER-AGENT: Firefox/44.3
              X-FORWARDED-FOR: 169.54.212.219
              X-FORWARDED-PORT: '80'
              X-FORWARDED-PROTO: http
        incident_id:
          type: string
          title: Incident Id
          description: ID of challenge that was generated
          example: 9f06152824394345
          examples:
            - 9f06152824394345
        request_type:
          type: string
          title: Request Type
          description: The type of the request that generated an event
          example: block
          examples:
            - block
        session_request_count:
          type: string
          title: Session Request Count
          description: The number requests in session
          example: '1'
          examples:
            - '1'
        domain:
          type: string
          title: Domain
          description: Domain name
          example: example.com
          examples:
            - example.com
        requested_domain:
          type: string
          title: Requested Domain
          description: The real domain name
          example: example.com
          examples:
            - example.com
        query_string:
          type: string
          title: Query String
          description: The query string of the request
          example: q=select%20user%20from%20master..a
          examples:
            - q=select%20user%20from%20master..a
        result:
          type: string
          enum:
            - passed
            - blocked
            - suppressed
            - ''
          title: Result
          description: The result of a request
          example: passed
          examples:
            - passed
        decision:
          type: string
          enum:
            - passed
            - allowed
            - monitored
            - blocked
            - ''
          title: Decision
          description: The decision made for processing the request through the WAAP.
          default: ''
          example: blocked
          examples:
            - blocked
        optional_action:
          type: string
          enum:
            - captcha
            - challenge
            - ''
          title: Optional Action
          description: >-
            An optional action that may be applied in addition to the primary
            decision.
          default: ''
          example: captcha
          examples:
            - captcha
        traffic_types:
          items:
            type: string
          type: array
          title: Traffic Types
          description: List of traffic types
          example:
            - sanctioned
            - policy_blocked
          examples:
            - - sanctioned
              - policy_blocked
        pattern_matched_tags:
          items:
            $ref: '#/components/schemas/PatternMatchedTag'
          type: array
          title: Pattern Matched Tags
          description: List of shield tags
        common_tags:
          items:
            $ref: '#/components/schemas/CommonTag'
          type: array
          title: Common Tags
          description: List of common tags
        ja3:
          type: string
          title: Ja3
          description: >-
            JA3 TLS client fingerprint as a 32-character lowercase hexadecimal
            MD5 hash, or an empty string when the record has no JA3 value.
          default: ''
          example: e7d705a3286e19ea42f587b344ee6865
          examples:
            - e7d705a3286e19ea42f587b344ee6865
      type: object
      required:
        - id
        - path
        - method
        - action
        - rule_id
        - rule_name
        - user_agent
        - network
        - request_time
        - reference_id
        - session_id
        - content_type
        - scheme
        - http_status_code
        - http_version
        - response_time
        - request_headers
        - incident_id
        - request_type
        - session_request_count
        - domain
        - requested_domain
        - query_string
        - result
        - traffic_types
        - pattern_matched_tags
        - common_tags
      title: RequestDetails
      description: Request's details used when displaying a single request.
    APIError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
      type: object
      required:
        - type
        - title
        - status
        - detail
      title: APIError
    APICompositeError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
        errors:
          items:
            $ref: '#/components/schemas/APIFieldError'
          type: array
          title: Errors
          description: A list of detailed errors for individual fields.
      type: object
      required:
        - type
        - title
        - status
        - detail
        - errors
      title: APICompositeError
    UserAgent:
      properties:
        full_string:
          type: string
          title: Full String
          description: User agent
          example: >-
            Mozilla/5.0 (X11; U; Linux x86_64; en-US) AppleWebKit/537.36 (KHTML,
            like Gecko) Chrome/30.1.1599.114 Safari/537.36 Puffin/4.5.0IT
          examples:
            - >-
              Mozilla/5.0 (X11; U; Linux x86_64; en-US) AppleWebKit/537.36
              (KHTML, like Gecko) Chrome/30.1.1599.114 Safari/537.36
              Puffin/4.5.0IT
        client:
          type: string
          title: Client
          description: Client from User agent header
          example: Firefox
          examples:
            - Firefox
        client_version:
          type: string
          title: Client Version
          description: User agent client version
          example: '44.3'
          examples:
            - '44.3'
        base_browser:
          type: string
          title: Base Browser
          description: User agent browser
          example: Chrome
          examples:
            - Chrome
        base_browser_version:
          type: string
          title: Base Browser Version
          description: User agent browser version
          example: 47.0.2526.83
          examples:
            - 47.0.2526.83
        os:
          type: string
          title: Os
          description: User agent os
          example: Android
          examples:
            - Android
        device:
          type: string
          title: Device
          description: User agent device
          example: Amazon Kindle Fire HDX 7
          examples:
            - Amazon Kindle Fire HDX 7
        device_type:
          type: string
          title: Device Type
          description: User agent device type
          example: mobile
          examples:
            - mobile
        cpu:
          type: string
          title: Cpu
          description: User agent cpu
          example: intel
          examples:
            - intel
        rendering_engine:
          type: string
          title: Rendering Engine
          description: User agent engine
          example: AppleWebKit
          examples:
            - AppleWebKit
        client_type:
          type: string
          title: Client Type
          description: User agent client type
          example: Custom Browser
          examples:
            - Custom Browser
      type: object
      required:
        - full_string
        - client
        - client_version
        - base_browser
        - base_browser_version
        - os
        - device
        - device_type
        - cpu
        - rendering_engine
        - client_type
      title: UserAgent
      description: User agent details
    Network:
      properties:
        client_ip:
          type: string
          title: Client Ip
          description: Client IP
          example: 116.83.107.125
          examples:
            - 116.83.107.125
        country:
          type: string
          title: Country
          description: Country code
          example: IL
          examples:
            - IL
        organization:
          $ref: '#/components/schemas/app__models__requests__Organization'
      type: object
      required:
        - client_ip
        - country
        - organization
      title: Network
      description: Network details
    PatternMatchedTag:
      properties:
        tag:
          type: string
          title: Tag
          description: Tag name
          example: sql
          examples:
            - sql
        display_name:
          type: string
          title: Display Name
          description: The tag's display name
          example: SQL Injection
          examples:
            - SQL Injection
        description:
          type: string
          title: Description
          description: Tag description information
          example: >-
            This client attempted insertion or “injection” of a SQL query via
            the input data from the client to the application. A successful SQL
            injection exploit can read sensitive data from the database, modify
            database data, etc.
          examples:
            - >-
              This client attempted insertion or “injection” of a SQL query via
              the input data from the client to the application. A successful
              SQL injection exploit can read sensitive data from the database,
              modify database data, etc.
        field:
          type: string
          title: Field
          description: >-
            The entity to which the variable that triggered the tag belong to.
            For example: `request_headers`, uri, cookies etc.
          example: uri
          examples:
            - uri
        field_name:
          type: string
          title: Field Name
          description: >-
            The name of the variable which holds the value that triggered the
            tag
          example: q
          examples:
            - q
        pattern_name:
          type: string
          title: Pattern Name
          description: The name of the detected regexp pattern
          example: SQL Injection Prevention
          examples:
            - SQL Injection Prevention
        pattern_value:
          type: string
          title: Pattern Value
          description: The pattern which triggered the tag
          example: select user from master..
          examples:
            - select user from master..
        execution_phase:
          type: string
          title: Execution Phase
          description: >-
            The phase in which the tag was triggered: access -> Request,
            `header_filter` -> `response_header`, `body_filter` ->
            `response_body`
          example: access
          examples:
            - access
      type: object
      required:
        - tag
        - display_name
        - description
        - field
        - field_name
        - pattern_name
        - pattern_value
        - execution_phase
      title: PatternMatchedTag
      description: Pattern matched tag details
    CommonTag:
      properties:
        tag:
          type: string
          title: Tag
          description: Tag name
          example: injectionattack
          examples:
            - injectionattack
        display_name:
          type: string
          title: Display Name
          description: The tag's display name
          example: Injection Attack
          examples:
            - Injection Attack
        description:
          type: string
          title: Description
          description: Tag description information
          example: Multiple injection attempts were detected.
          examples:
            - Multiple injection attempts were detected.
      type: object
      required:
        - tag
        - display_name
        - description
      title: CommonTag
      description: Common tag details
    APIFieldError:
      properties:
        loc:
          anyOf:
            - items:
                anyOf:
                  - type: integer
                  - type: string
              type: array
            - {}
          title: Loc
          description: The location of the field or a character number causing the error.
        detail:
          type: string
          title: Detail
          description: A human-readable message describing the error.
      type: object
      required:
        - loc
        - detail
      title: APIFieldError
    app__models__requests__Organization:
      properties:
        name:
          type: string
          title: Name
          description: Organization name
          example: InfoWeb(Fujitsu Ltd
          examples:
            - InfoWeb(Fujitsu Ltd
        subnet:
          type: string
          title: Subnet
          description: Network range
          example: 116.83.0.0-116.83.127.255
          examples:
            - 116.83.0.0-116.83.127.255
      type: object
      required:
        - name
        - subnet
      title: Organization
      description: Organization details
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````